<?php
c_include('extApp');

class LastfmExtApp extends ExtApp {
	var $auth = false;
	
	function __construct($aplicacion){
		parent::__construct($aplicacion);
	}
	
	function includes(){
		c_include('extension','app','usuario','helpers/appsHelper','uploader/uploader');
	}
	
	/* FUNCIONES GENERALES */
	
	function authenticateApp($scope='gestionar_busqueda_externa'){
		if (empty($scope))
			$scope = 'gestionar_busqueda_externa';

		if ($this->activo == '1' && (empty($scope) || $this->parametros[$scope] == '1')){
			if (!empty($_GET['token'])){
				@session_start();
				$_SESSION[CLAVE_SECRETA]['apps'][$this->nombre]['token'] = $_GET['token'];
				Helpers::redirect(CONF_URL_APP.$this->getApiUrl('autorizar','system-msg',false));
				exit;
			}
			
			if ($this->isAuthenticatedApp($scope)){
				return true;
			} else {
				$apiKey = $this->parametros['apiKey'];
			
				$url_login = 'http://www.last.fm/api/auth/?api_key='.$apiKey.'&cb='.Helpers::currentUrl();
				
				Helpers::redirect($url_login);
				exit;
			}
		} else {
			return false;
		}
	}
	
	function unauthenticateApp(){
		if ($this->isAuthenticatedApp()){
			@session_start();
			unset($_SESSION[CLAVE_SECRETA]['apps'][$this->nombre]['token']);
			return true;
		} else {
			return false;
		}
	}
	
	function isAuthenticatedApp($scope=''){
		if (!empty($_SESSION[CLAVE_SECRETA]['apps'][$this->nombre]['token'])){
			$this->auth = $_SESSION[CLAVE_SECRETA]['apps'][$this->nombre]['token'];
		}
		if ($this->auth === false){
			return false;
		} else {
			return true;
		}
	}
	
	/* FUNCIONES DE BUSQUEDA EXTERNA */
	
	function busquedaExterna($q, $limit=5){
		if (empty($limit))
			$limit = 5;
			
		$url = 'http://ws.audioscrobbler.com/2.0/?method=artist.search&artist='.urlencode($q).'&limit='.$limit.'&api_key='.$this->parametros['apiKey'].'&format=json';
		
		$content = file_get_contents($url);
		$json = json_decode($content, true);
		
		if ($json["results"]["opensearch:totalResults"] > 1 && !isset($json["results"]["artistmatches"]["artist"]["name"])){
	
			$results_lastfm = $json["results"]["artistmatches"]["artist"];
			
			if (is_array($results_lastfm) && sizeof($results_lastfm) > 0){
				foreach ($results_lastfm as $kres=>$res){
					$info_item = $this->infoItemBusquedaExterna($res["name"], $res["mbid"]);

					$results[] = $info_item;
				}
			}
		
		} elseif (!empty($json["results"]["artistmatches"]["artist"]["name"])) {
			$results_lastfm = $json["results"]["artistmatches"]["artist"];
			
			$info_item = $this->infoItemBusquedaExterna($results_lastfm["name"], $results_lastfm["mbid"]);
			$results[] = $info_item;
		}
		
		return $results;
	}
	
	function infoItemBusquedaExterna($id, $mbid, $fakeobj=true){
		$result = false;
		
		$item_model = null;
		if (!empty($this->parametros['tipo_item_nuevo'])){
			$exp_im = explode(':', $this->parametros['tipo_item_nuevo']);
			
			if (sizeof($exp_im) == 2){
				
				$all_ext_ite = Helpers::getExtensionsClasses('item');
				
				if (is_array($all_ext_ite[$exp_im[0]]) && sizeof($all_ext_ite[$exp_im[0]]) > 0){
					$sel_ext_ite = $all_ext_ite[$exp_im[0]];
					
					if ($sel_ext_ite['vista'] == $exp_im[1]){
						$class_name_ite = $sel_ext_ite['class'];
						
						if (class_exists($class_name_ite)){
							$item_model = new $class_name_ite();
						}
					}
				}
			
			}
		}
		
		if (is_object($item_model)){
			$item_existe = $item_model->ListarCount("titulo LIKE '%\"".addslashes($id)."\"%'");
			
			if ($item_existe > 0){
				$item_model = $item_model->Listar("titulo LIKE '%\"".addslashes($id)."\"%'");
				$item_model = $item_model[0];
				$result = get_object_vars($item_model);
			} else {
				$url = 'http://ws.audioscrobbler.com/2.0/?method=artist.getinfo&artist='.urlencode($id).'&lang='.SistemaIdioma::getIdiomaSesion().'&autocorrect=1&api_key='.$this->parametros['apiKey'].'&format=json';
				if (!empty($mbid)){
					$url .= '&mbid='.$mbid;
				}
				$content = file_get_contents($url);
				$json = json_decode($content, true);
				
				$result = $json["artist"];
				
				$result['bio']['content'] = html_entity_decode(trim(strip_tags(nl2br($result['bio']['content']))));
				$trozos_bio = preg_split("/((\r?\n)|(\r\n?))/", $result['bio']['content']);
				
				if (!empty($trozos_bio[0])){
					$result['bio']['content'] = $trozos_bio[0];
				} else {
					$result['bio']['content'] = '';
				}
				
				if (is_array($result['tags']['tag']) && sizeof($result['tags']['tag']) > 0){
					$categorias = array();
					
					$all_ext_cat = Helpers::getExtensionsClasses('category');
					
					if (is_array($all_ext_cat[$exp_im[0]]) && sizeof($all_ext_cat[$exp_im[0]]) > 0){
						
						$class_name_cat = $all_ext_cat[$exp_im[0]]['class'];
						
						if (class_exists($class_name_cat)){						
						
							foreach ($result['tags']['tag'] as $t){
								$alias_t = ucfirst(Helpers::parseaTexto($t['name']));
				
								$em = new $class_name_cat();
								$em->setalias($alias_t);
								
								if ($em = $em->BuscarPorAlias($alias_t)){
									$categorias[] = (string) $em->id;
								}
							}
						
						}
					
					}
				}
				
				$result['categorias'] = $categorias;
				
				if (sizeof($categorias) == 0){
					return false;
				}
				
				$titulo = addslashes($result['name']);
				$imagen = $result['image'][count($result['image'])-1]["#text"];
				$contenido = $result['bio']['content'];
				
				$result_parsed = array("titulo"=>$titulo, "contenido"=>$contenido, "imagen_destacada"=>$imagen, "categorias"=>$categorias, "estado"=>1);
				
				$creador = 0;
				$creador_alias = '';
				if (Usuario::isLoged()){
					$creador_obj = new Usuario(Usuario::getLogedId());

					if ($creador_obj){
						$creador = -$creador_obj->id;
						if (empty($creador_alias)){
							$creador_alias = $creador_obj->getnombre_completo();
						}
					}
				}
				
				$idioma = SistemaIdioma::getIdiomaSesion();
				
				if (empty($result_parsed['accion'])){
					$result_parsed['accion'] = 'nuevo';
				}
				
				$result_parsed['creador'] = $creador;
				
				foreach ($result_parsed as $kpost=>$pos){
					if (in_array($kpost, $item_model->get('campos_multilang'))){
						$tmp_lang = array($idioma=>$result_parsed[$kpost]);
						$result_parsed[$kpost] = $tmp_lang;
					}
				}
				
				$detalles_posted = $result_parsed;
				unset($detalles_posted['id_form'], $detalles_posted['token'], $detalles_posted['params']);
				
				$params_posted = is_array($result_parsed['params']) ? $result_parsed['params'] : array();
				
				$array_completo[$item_model->get('ext_folder')]['detalles'] = $detalles_posted;
				$array_completo[$item_model->get('ext_folder')]['avanzadas'] = $params_posted;
				
				$guardado_item = $item_model->guardarPost($array_completo, false, $fakeobj);
				
				if ($fakeobj && $guardado_item instanceof ItemModel){
					$guardado_item->getInfo();
					$guardado_item->setid(json_encode(array("id"=>$id,"mbid"=>$mbid,"item"=>$guardado_item->get('ext_folder').':'.$guardado_item->get('ext_vista_item'),"token"=>Helpers::getFormToken())));
					$guardado_item->app_fake_obj = Helpers::parseaTexto(ucfirst($this->nombre));
					
					$result = get_object_vars($guardado_item);
				} elseif ($fakeobj == false && $guardado_item === true){
					$item_model = new $class_name_ite();
					$id_last_item = $GLOBALS['last_id'][$item_model->get('ext_folder')][$item_model->get('ext_vista_item')];
					$item_model->setid($id_last_item);
					
					if ($item_model = $item_model->BuscarId()){
						$result = get_object_vars($item_model);
					} else {
						return false;
					}

					
				} else {
					return false;
				}
			}
		} else {
			return false;
		}
		
		return $result;
	}
	
	function guardarItem($vars=null){
		if (empty($vars) || !is_array($vars))
			return __('Los valores enviados no son correctos');
			
		if (empty($vars['id']) && empty($var['mbid']))
			return __('Formato de valores incorrecto');
			
		if (empty($vars['item']))
			return __('No se ha definido el tipo de item a crear');
			
		if ($vars['item'] != $this->parametros['tipo_item_nuevo'])
			return __('La clase del item a crear no coincide');
			
		$result = $this->infoItemBusquedaExterna($vars['id'], $vars['mbid'], false);
			
		return $result;
	}
	
}
?>